/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Close.c,v 1.3 1994/02/18 20:35:52 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Close.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <Xm/Xm.h>
#include <Xm/Protocols.h>
#include <Xm/MwmUtil.h>

#include "Xn.h"

void            XnSetFrameClose (Widget shell, XtCallbackProc proc, XtPointer data)
{
    Atom atom;

    shell = XnGetShell (shell);

    XtVaSetValues (shell,
       XmNdeleteResponse, XmDO_NOTHING,
       NULL);

    atom = XInternAtom (XtDisplay (shell), "WM_DELETE_WINDOW", False);
    XmAddWMProtocols (shell, &atom, 1);
    XmAddWMProtocolCallback (shell, atom, proc, data);
}

void            XnSetNoResize (Widget shell)
{
    int func;

    shell = XnGetShell (shell);

    XtVaGetValues (shell, XmNmwmFunctions, &func, NULL);

    if (func == -1)
	func = MWM_FUNC_ALL | MWM_FUNC_RESIZE | MWM_FUNC_MAXIMIZE;
    else
	func |= (MWM_FUNC_RESIZE | MWM_FUNC_MAXIMIZE);

    XtVaSetValues (shell, XmNmwmFunctions, func, NULL);
}
