/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Position.c,v 1.2 1994/02/18 20:35:55 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Position.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <stdio.h>

#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Xm.h>

#include "Xn.h"

#define KEY      "! foofoofoofoo\n"
#define KEYLEN   12
#define BUF_SIZE 256

static void     ChangeXY (file, name, x, y)
char           *file;
char           *name;
Position        x, y;
{
    char            buffer[BUF_SIZE];
    char            tmpfile[80];
    char            tmpname[80];
    FILE           *outfile, *infile, *fopen ();
    int             found_it = 0;
    int             len;

    /* generate uniquely-named temporary */
    sprintf (tmpfile, "/tmp/windowPos.%d", getpid ());

    if ((infile = fopen (file, "r")) == NULL) {
	printf ("unable to open resource file\n");
	return;
    }
    if ((outfile = fopen (tmpfile, "w")) == NULL) {
	printf ("unable to open temp file\n");
	return;
    }
    /* read until we get to the delimiter key */
    while (fgets (buffer, BUF_SIZE, infile) != NULL) {
	fputs (buffer, outfile);
	if (!strncmp (buffer, KEY, KEYLEN)) {
	    found_it = 1;
	    break;
	}
    }
    /* if no delimiter key then write one out */
    if (!found_it) {
	fputs ("\n! Do not delete. Window position data follows. \n", outfile);
	fputs (KEY, outfile);
    }

    /*
     * otherwise write out all position info except for the one we are
     * updating
     */
    else {
	sprintf (tmpname, "%s.", name);	/* without the . tester would match
					 * test */
	len = strlen (tmpname);
	while (fgets (buffer, BUF_SIZE, infile) != NULL)
	    if (strncmp (buffer, tmpname, len))
		fputs (buffer, outfile);
    }

    /* update the position */
    sprintf (buffer, "%s.x: %d\n", name, x);
    fputs (buffer, outfile);
    sprintf (buffer, "%s.y: %d\n", name, y);
    fputs (buffer, outfile);

    fclose (infile);
    fclose (outfile);
    sprintf (buffer, "mv %s %s", tmpfile, file);
    system (buffer);
}

void            SavePosition (shell, resFile, nu2)
Widget          shell;
char           *resFile;
XtPointer         nu2;
{
    Arg             args[2];
    Position        x, y;
    char           *dir;
    int             len;
    char           *file;

    XtSetArg (args[0], XmNx, &x);
    XtSetArg (args[1], XmNy, &y);
    XtGetValues (shell, args, 2);

    dir = (char *) getenv ("XAPPLRESDIR");
    len = strlen (dir) + strlen (resFile) + 3;
    file = (char *) malloc (len);
    sprintf (file, "%s/%s", dir, resFile);

    ChangeXY (file, shell->core.name, x, y);

    XtFree (file);
}
