/*******************************<+>***************************
 **                             DTA
 *************************************************************
 **
 **  $Id: Primitive.h,v 1.2 1994/02/18 02:55:36 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Primitive.h,v $
 **
 **  What @(#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#ifndef _Primitive_h
#define _Primitive_h

#define XnDefaultScreen(w) \
	DefaultScreen (XtDisplay (w))

#define XnDefaultDepth(w) \
	DefaultDepth (XtDisplay (w), DefaultScreen (w))

#define XnDefaultColormap(w) \
	DefaultColormap (XtDisplay (w), XnDefaultScreen (w))

#define XnWhitePixel(w) \
	WhitePixel (XtDisplay (w), DefaultScreen (XtDisplay (w)))

#define XnBlackPixel(w) \
	BlackPixel (XtDisplay (w), DefaultScreen (XtDisplay (w)))

/*
 * Macros for Xlib functions
 */

#define XnAllocNamedColor(w, color, def, rgb) \
	XAllocNamedColor (XtDisplay (w), XnDefaultColormap (w), color, def, rgb)

#define XnClearWindow(w)\
    XClearWindow (XtDisplay (w), XtWindow (w))

#define XnCreateGC(w, mask, gcv)\
    XCreateGC (XtDisplay (w), XtWindow (w), mask, gcv)

#define XnCreatePixmap(w, width, height, depth) \
    XCreatePixmap (XtDisplay (w), XtWindow (w), width, height, depth)

#define XnDrawPoint(w, gc, x, y) \
    XDrawPoint (XtDisplay (w), XtWindow (w), gc, x, y)

#define XnDrawLine(w, gc, x1, y1, x2, y2) \
    XDrawLine (XtDisplay (w), XtWindow (w), gc, x1, y1, x2, y2)

#define XnSetBackground(w, gc, pixel)\
    XSetForeground (XtDisplay (w), gc, pixel)

#define XnSetForeground(w, gc, pixel)\
    XSetForeground (XtDisplay (w), gc, pixel)

#define XnSetWindowBackground(w, pixel)\
    XSetWindowBackground (XtDisplay (w), XtWindow (w), pixel)

#define XnSetWindowBackgroundPixmap(w, pixmap)\
    XSetWindowBackgroundPixmap (XtDisplay (w), XtWindow (w), pixmap)

/*
 * Intrinsic macros
 */

#define XnDestroyParent(w) \
    XtDestroyWidget (XtParent (w))

#define XnPopdownParent(w) \
    XtPopdown (XtParent (w))

#define XnGetWidthHeight(w, width, height) \
    XtVaGetValues (w, XmNwidth, width, XmNheight, height, NULL)

/*
 * New macros
 */

#define XnArrowTip(w, gc, angle, x, y, length) \
	XArrowTip (XtDisplay (w), XtWindow (w), gc, angle, x, y, length)

#endif
