/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Radio.c,v 1.5 1994/02/18 19:56:21 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Radio.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>
#include <Xm/SeparatoG.h>

#include <Xn/Xn.h>

Widget		XnCreateRadioButtons (parent, data)
Widget          parent;
XnCallbackData *data;
{
    Widget rb = XmCreateRadioBox (parent, "rb", NULL, 0);
    int i;

    for (i = 0; data[i].name; i++) {
	if (!data[i].data)
	    data[i].data = (XtPointer) parent;
	data[i].w = XtVaCreateManagedWidget (data[i].name,
	    xmToggleButtonGadgetClass, rb,
	    XmNuserData, i,
	    NULL);
	if (data[i].proc)
	    XnAddCallback (data[i].w, XmNvalueChangedCallback, data[i].proc, data[i].data);
    }

    XtManageChild (rb);

    return (rb);
}

Widget		XnCreatePushButtons (parent, data)
Widget          parent;
XnCallbackData *data;
{
    int             i;

    for (i = 0; data[i].name; i++) {
	if (data[i].name && *data[i].name) {
	    if (!data[i].data)
		data[i].data = (XtPointer) parent;
	    data[i].w = XtVaCreateManagedWidget (data[i].name,
		xmPushButtonGadgetClass, parent,
		NULL);
	    if (data[i].proc)
		XnAddCallback (data[i].w, XmNactivateCallback, data[i].proc, data[i].data);
	} else {
	    data[i].w = XtVaCreateManagedWidget ("separator",
		xmSeparatorGadgetClass, parent,
		NULL);
	}
    }
}

Widget		XnCreateToggleButtons (parent, data)
Widget          parent;
XnCallbackData *data;
{
    int             i;

    for (i = 0; data[i].name; i++) {
	if (*data[i].name) {
	    if (!data[i].data)
		data[i].data = (XtPointer) parent;
	    data[i].w = XtVaCreateManagedWidget (data[i].name,
		xmToggleButtonGadgetClass, parent,
		NULL);
	    if (data[i].proc)
		XnAddCallback (data[i].w, XmNvalueChangedCallback,
		    data[i].proc, data[i].data);
	} else {
	    data[i].w = XtVaCreateManagedWidget ("separator",
		xmSeparatorGadgetClass, parent,
		NULL);
	}
    }
}
