/*******************************<+>***************************
 **                             DTA
 *************************************************************
 **
 **  $Id: Status.c,v 1.3 1994/02/12 22:48:01 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Status.c,v $
 **
 **  What @(#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>

#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/TextF.h>

#include <Xn/Xn.h>

static Widget statusbar;

void XnStatusBarPrintf (const char *fmt, ...)
{
    char buffer [1024];
    va_list args;
    int va_alist;

    va_start (args, fmt);
    vsprintf (buffer, fmt, args);
    va_end (args);

    if (XtIsManaged (statusbar))
	XnWidgetPutStr (statusbar, buffer);
}

Widget XnCreateStatusBar (Widget parent)
{
    statusbar = XtVaCreateManagedWidget (" ",
	xmTextFieldWidgetClass, parent,
	XmNcursorPositionVisible, False,
	XmNeditable, False,
	NULL);

    if (XmIsForm (parent)) {
	XtVaSetValues (statusbar,
	    XmNleftAttachment, XmATTACH_FORM,
	    XmNrightAttachment, XmATTACH_FORM,
	    XmNbottomAttachment, XmATTACH_FORM,
	    NULL);
    }

    XnStatusBarPrintf ("Ready...");

    return statusbar;
}
