/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: Util.c,v 1.3 1994/02/13 06:42:46 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Util.c,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#include <Xn/Xn.h>

#include <Xm/DialogS.h>

void XnPopupNearMouse (Widget shell)
{
    Arg             args[2];
    Window          root, child, window;
    int             rootx, rooty, winx, winy;
    unsigned int    mask;

    window = XtWindow (shell);

    XQueryPointer (XtDisplay (shell), window,
		   &root, &child,
		   &rootx, &rooty, &winx, &winy,
		   &mask);

    XtSetArg (args[0], XmNx, rootx);
    XtSetArg (args[1], XmNy, rooty);
    XtSetValues (shell, args, 2);

    XtPopup (shell, XtGrabExclusive);
}

void XnCenterOnMouse (Widget shell)
{
    Arg             args[2];
    Window          root, child, window;
    int             rootx, rooty, winx, winy;
    unsigned int    mask;
    Dimension       h, w;

    if (XtIsManaged (shell)) {
	XtSetArg (args[0], XmNheight, &h);
	XtSetArg (args[1], XmNwidth, &w);
	XtGetValues (shell, args, 2);

	window = XtWindow (shell);

	XQueryPointer (XtDisplay (shell), window,
		       &root, &child,
		       &rootx, &rooty, &winx, &winy,
		       &mask);
	XtSetArg (args[0], XmNx, rootx - w / 2);
	XtSetArg (args[1], XmNy, rooty - h / 2);
	XtSetValues (shell, args, 2);
    }
}

void XnSetWidgetPosition (Widget w, int pos)
{
    Dimension       width;

    XtVaGetValues (w,
	XmNwidth, &width,
	NULL);

    XtVaSetValues (w,
	XmNleftOffset, -(width / 2),
	XmNrightOffset, -(width / 2),
	XmNleftAttachment, XmATTACH_POSITION,
	XmNrightAttachment, XmATTACH_POSITION,
	XmNleftPosition, pos,
	XmNrightPosition, pos,
	NULL);
}

Widget XnGetShell (Widget w)
{
    int catch;

    for (catch = 0; w && catch < 10; w = XtParent (w), catch++)
	if (XmIsDialogShell (w) || XmIsVendorShell (w))
	    break;
    return w;
}

void XnPopdown (Widget shell)
{
    shell = XnGetShell (shell);
    XtUnmanageChild (shell);
    XtPopdown (shell);
}

void XnDestroyDialog (Widget shell)
{
    shell = XnGetShell (shell);
    XtUnmanageChild (shell);
    XtPopdown (shell);
    XtDestroyWidget (shell);
}

void XnSetMinSize (Widget w)
{
    int width;
    int height;

    w = XnGetShell (w);

    XtVaGetValues (w,
	XmNwidth, &width,
	XmNheight, &height,
	NULL);

    XtVaSetValues (w,
	XmNminWidth, &width,
	XmNminHeight, &height,
	NULL);
}

void XnSetMaxSize (Widget w)
{
    int width;
    int height;

    w = XnGetShell (w);

    XtVaGetValues (w,
	XmNwidth, &width,
	XmNheight, &height,
	NULL);

    XtVaSetValues (w,
	XmNmaxWidth, &width,
	XmNmaxHeight, &height,
	NULL);
}

