/*******************************<+>***************************
 **                             PRC
 *************************************************************
 **
 **  $Id: GraphP.h,v 1.1.1.1 1993/05/17 17:33:25 dta Exp $
 **
 **  $Source: /cvs/lib/xn/Widgets/GraphP.h,v $
 **
 **  Module Name:
 **
 **  Classification:  Unclassified
 **
 **  Author:          Dale T. Anderson
 **
 *******************************<+>***************************/

#ifndef _GraphP_h
#define _GraphP_h

#include <Xm/XmP.h>
#include <Xm/DrawingAP.h>
#include <Xn/Graph.h>

/*
 * New fields for the Graph widget class record
 */

typedef struct {
    XtPointer       extension;
}               XnGraphClassPart;

/*
 * Full class record declaration
 */
typedef struct _XnGraphClassRec {
    CoreClassPart   core_class;
    XmDrawingAreaClassPart drawing_class;
    XnGraphClassPart graph_class;
}               XnGraphClassRec;

extern XnGraphClassRec xnGraphClassRec;

typedef struct {
    float           factor;
    XPoint         *data;

    short           min;
    short           max;
    int             count;
    long            fg;
    float           xratio;
    float           yratio;
    char           *format;

    int             filled;

    char           *header;
    char           *footer;
}               XnFunction;

typedef struct _GraphData {
    /* resources */

    XnGraphType       type;

    int             selected;

    int             v_labels;
    int             h_labels;

    int             grid_lines;

    int             xspace;
    int             yspace;

    XmFontList		font_list;

    /* private state */

    Pixmap          pixmap;
    GC              gc;		/* gc used for display */

    Pixel           fg;
    Pixel           bg;

    int             x1;		/* upper left corner of the graph area */
    int             y1;		/* upper left corner of the graph area */
    int             x2;		/* lower right corner of the graph area */
    int             y2;		/* lower right corner of the graph area */

    int             count;	/* number of functions */
    XnFunction *f;		/* array of functions */
}               XnGraphPart;

/*
 * Full instance record declaration
 */
typedef struct _XnGraphRec {
    CorePart        core;
    XmDrawingAreaPart   drawing;
    XnGraphPart     graph;
}               XnGraphRec;

#endif
