/*
 * Copyright(c) 1992 Bell Communications Research, Inc. (Bellcore)
 *                        All rights reserved
 * Permission to use, copy, modify and distribute this material for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of Bellcore not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * Bellcore.
 *
 * BELLCORE MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL BELLCORE OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES RELAT-
 * ING TO THE SOFTWARE.
 *
 * ClipWidget Author: Andrew Wason, Bellcore, aw@n.bellcore.com
 */

/*
 * ClipP.h - Private definitions for Clip widget
 */

#ifndef _Xn_ClipP_h
#define _Xn_ClipP_h

/*
 *  "@(#)ClipP.h	3.4 7/8/92"
 */

#include <Xm/XmP.h>
#include <Xn/Clip.h>

/*
 * New type for class method
 */

#if defined (__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

typedef void (*XnClipRedrawProc)(
#if NeedFunctionPrototypes
				   Widget	/* w */
#endif
				   );

#if defined (__cplusplus) || defined(c_plusplus)
}
#endif

/*
 * New fields for the Clip widget class record
 */
typedef struct {
    XnClipRedrawProc	redraw;
    XtPointer		extension;
} XnClipClassPart;

/*
 * Full class record declaration
 */
typedef struct _XnClipClassRec {
    CoreClassPart		core_class;
    XmPrimitiveClassPart	primitive_class;
    XnClipClassPart		clip_class;
} XnClipClassRec;

extern XnClipClassRec xnClipClassRec;

/*
 * New inheritance constant
 */
#define XnInheritRedraw ((XnClipRedrawProc) _XtInherit)

/*
 * New fields for the Clip widget record
 */
typedef struct {
    /* resources */
    XtExposeProc	expose_proc;	/* function to call on expose */
    XtCallbackList	focus_callback;	/* callbacks for when we get focus */
} XnClipPart;

/*
 * Full instance record declaration
 */
typedef struct _XnClipRec {
    CorePart		core;
    XmPrimitivePart	primitive;
    XnClipPart	clip;
} XnClipRec;

#endif /* _Xn_ClipP_h */
