/*******************************<+>***************************
 **                     DTA
 *************************************************************
 **
 **  $Id: Main.C,v 1.2 1994/02/14 19:31:32 dta Exp $
 **
 **  $Source: /cvs/progs/pexenum/Main.C,v $
 **
 **  What @ (#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <Xn/Xn.h>
#include <Xm/Label.h>
#include <Xm/Text.h>
#include <Xm/Form.h>
#include <Xm/List.h>

#include <X11/PEX5/PEXlib.h>

static PEXEnumTypeDesc *find_option (PEXEnumTypeDesc *enums, const int count, const int index, const char *descriptor)
{
    for (int i = 0; i < count; i++)
	if (index == enums[i].index && !strcmp (enums[i].descriptor, descriptor))
	    return enums + i;

    return NULL;
}

static PEXEnumTypeDesc standards[] = {
    { PEXETATextStyle, "ATextStyle" },
    { PEXETColorApproxModel, "ColorApproxModel" },
    { PEXETColorApproxType, "ColorApproxType" },
    { PEXETColorType, "ColorType" },
    { PEXETCurveApproxMethod, "CurveApproxMethod" },
    { PEXETDisplayUpdateMode, "DisplayUpdateMode" },
    { PEXETEscape, "Escape" },
    { PEXETFloatFormat, "FloatFormat" },
    { PEXETGDP2D, "GDP2D" },
    { PEXETGDP, "GDP" },
    { PEXETGSE, "GSE" },
    { PEXETHatchStyle, "HatchStyle" },
    { PEXETHLHSRMode, "HLHSRMode" },
    { PEXETInteriorStyle, "InteriorStyle" },
    { PEXETLightType, "LightType" },
    { PEXETLineType, "LineType" },
    { PEXETMarkerType, "MarkerType" },
    { PEXETModelClipOperator, "ModelClipOperator" },
    { PEXETParaSurfCharacteristics, "ParaSurfCharacteristics" },
    { PEXETPickAllMethod, "PickAllMethod" },
    { PEXETPickDeviceType, "PickDeviceType" },
    { PEXETPickOneMethod, "PickOneMethod" },
    { PEXETPolylineInterpMethod, "PolylineInterpMethod" },
    { PEXETPromptEchoType, "PromptEchoType" },
    { PEXETReflectionModel, "ReflectionModel" },
    { PEXETRenderingColorModel, "RenderingColorModel" },
    { PEXETSurfaceApproxMethod, "SurfaceApproxMethod" },
    { PEXETSurfaceEdgeType, "SurfaceEdgeType" },
    { PEXETSurfaceInterpMethod, "SurfaceInterpMethod" },
    { PEXETTrimCurveApproxMethod, "TrimCurveApproxMethod" }
};

static PEXEnumTypeDesc options[] = {
    { PEXETATextStyle, PEXETMATextNotConnected },
    { PEXETATextStyle, PEXETMATextConnected },
    { PEXETColorApproxModel, PEXETMColorApproxRGB },
    { PEXETColorApproxModel, PEXETMColorApproxCIE },
    { PEXETColorApproxModel, PEXETMColorApproxHSV },
    { PEXETColorApproxModel, PEXETMColorApproxHLS },
    { PEXETColorApproxModel, PEXETMColorApproxYIQ },
    { PEXETColorApproxType, PEXETMColorSpace },
    { PEXETColorApproxType, PEXETMColorRange },
    { PEXETColorType, PEXETMColorTypeIndexed },
    { PEXETColorType, PEXETMColorTypeRGB },
    { PEXETColorType, PEXETMColorTypeCIE },
    { PEXETColorType, PEXETMColorTypeHSV },
    { PEXETColorType, PEXETMColorTypeHLS },
    { PEXETColorType, PEXETMColorTypeRGB8 },
    { PEXETColorType, PEXETMColorTypeRGB16 },
    { PEXETCurveApproxMethod, PEXETMApproxConstantBetweenKnots },
    { PEXETCurveApproxMethod, PEXETMApproxWCChordalSize },
    { PEXETCurveApproxMethod, PEXETMApproxNPCChordalSize },
    { PEXETCurveApproxMethod, PEXETMApproxDCChordalSize },
    { PEXETCurveApproxMethod, PEXETMCurveApproxWCChordalDev },
    { PEXETCurveApproxMethod, PEXETMCurveApproxNPCChordalDev },
    { PEXETCurveApproxMethod, PEXETMCurveApproxDCChordalDev },
    { PEXETCurveApproxMethod, PEXETMApproxWCRelative },
    { PEXETCurveApproxMethod, PEXETMApproxNPCRelative },
    { PEXETCurveApproxMethod, PEXETMApproxDCRelative },
    { PEXETDisplayUpdateMode, PEXETMVisualizeEach },
    { PEXETDisplayUpdateMode, PEXETMVisualizeEasy },
    { PEXETDisplayUpdateMode, PEXETMVisualizeNone },
    { PEXETDisplayUpdateMode, PEXETMSimulateSome },
    { PEXETDisplayUpdateMode, PEXETMVisualizeWhenever },
    { PEXETEscape, PEXETMEscapeSetEchoColor },
    { PEXETFloatFormat, PEXETMIEEE_754_32 },
    { PEXETFloatFormat, PEXETMDEC_F_Floating },
    { PEXETFloatFormat, PEXETMIEEE_754_64 },
    { PEXETFloatFormat, PEXETMDEC_D_Floating },
    { PEXETHLHSRMode, PEXETMHLHSROff },
    { PEXETHLHSRMode, PEXETMHLHSRZBuffer },
    { PEXETHLHSRMode, PEXETMHLHSRPainters },
    { PEXETHLHSRMode, PEXETMHLHSRScanline },
    { PEXETHLHSRMode, PEXETMHLHSRHiddenLineOnly },
    { PEXETHLHSRMode, PEXETMHLHSRZBufferID },
    { PEXETInteriorStyle, PEXETMInteriorStyleHollow },
    { PEXETInteriorStyle, PEXETMInteriorStyleSolid },
    { PEXETInteriorStyle, PEXETMInteriorStylePattern },
    { PEXETInteriorStyle, PEXETMInteriorStyleHatch },
    { PEXETInteriorStyle, PEXETMInteriorStyleEmpty },
    { PEXETLightType, PEXETMLightAmbient },
    { PEXETLightType, PEXETMLightWCVector },
    { PEXETLightType, PEXETMLightWCPoint },
    { PEXETLightType, PEXETMLightWCSpot },
    { PEXETLineType, PEXETMLineTypeSolid },
    { PEXETLineType, PEXETMLineTypeDashed },
    { PEXETLineType, PEXETMLineTypeDotted },
    { PEXETLineType, PEXETMLineTypeDashDot },
    { PEXETMarkerType, PEXETMMarkerDot },
    { PEXETMarkerType, PEXETMMarkerCross },
    { PEXETMarkerType, PEXETMMarkerAsterisk },
    { PEXETMarkerType, PEXETMMarkerCircle },
    { PEXETMarkerType, PEXETMMarkerX },
    { PEXETModelClipOperator, PEXETMModelClipReplace },
    { PEXETModelClipOperator, PEXETMModelClipIntersection },
    { PEXETParaSurfCharacteristics, PEXETMPSCNone },
    { PEXETParaSurfCharacteristics, PEXETMPSCIsoCurves },
    { PEXETParaSurfCharacteristics, PEXETMPSCMCLevelCurves },
    { PEXETParaSurfCharacteristics, PEXETMPSCWCLevelCurves },
    { PEXETPickAllMethod, PEXETMPickAllAll },
    { PEXETPickAllMethod, PEXETMPickAllVisible },
    { PEXETPickDeviceType, PEXETMPickDeviceDCHitBox },
    { PEXETPickDeviceType, PEXETMPickDeviceNPCHitVolume },
    { PEXETPickOneMethod, PEXETMPickLast },
    { PEXETPickOneMethod, PEXETMPickClosestZ },
    { PEXETPickOneMethod, PEXETMPickVisibleAny },
    { PEXETPickOneMethod, PEXETMPickVisibleClosest },
    { PEXETPolylineInterpMethod, PEXETMPolylineInterpNone },
    { PEXETPolylineInterpMethod, PEXETMPolylineInterpColor },
    { PEXETPromptEchoType, PEXETMEchoPrimitive },
    { PEXETPromptEchoType, PEXETMEchoStructure },
    { PEXETPromptEchoType, PEXETMEchoNetwork },
    { PEXETReflectionModel, PEXETMReflectionNone },
    { PEXETReflectionModel, PEXETMReflectionAmbient },
    { PEXETReflectionModel, PEXETMReflectionDiffuse },
    { PEXETReflectionModel, PEXETMReflectionSpecular },
    { PEXETRenderingColorModel, PEXETMRenderingColorModelRGB },
    { PEXETRenderingColorModel, PEXETMRenderingColorModelCIE },
    { PEXETRenderingColorModel, PEXETMRenderingColorModelHSV },
    { PEXETRenderingColorModel, PEXETMRenderingColorModelHLS },
    { PEXETSurfaceApproxMethod, PEXETMApproxConstantBetweenKnots },
    { PEXETSurfaceApproxMethod, PEXETMApproxWCChordalSize },
    { PEXETSurfaceApproxMethod, PEXETMApproxNPCChordalSize },
    { PEXETSurfaceApproxMethod, PEXETMApproxDCChordalSize },
    { PEXETSurfaceApproxMethod, PEXETMSurfaceApproxWCPlanarDev },
    { PEXETSurfaceApproxMethod, PEXETMSurfaceApproxNPCPlanarDev },
    { PEXETSurfaceApproxMethod, PEXETMSurfaceApproxDCPlanarDev },
    { PEXETSurfaceApproxMethod, PEXETMApproxWCRelative },
    { PEXETSurfaceApproxMethod, PEXETMApproxNPCRelative },
    { PEXETSurfaceApproxMethod, PEXETMApproxDCRelative },
    { PEXETSurfaceEdgeType, PEXETMSurfaceEdgeSolid },
    { PEXETSurfaceEdgeType, PEXETMSurfaceEdgeDashed },
    { PEXETSurfaceEdgeType, PEXETMSurfaceEdgeDotted },
    { PEXETSurfaceEdgeType, PEXETMSurfaceEdgeDashDot },
    { PEXETSurfaceInterpMethod, PEXETMSurfaceInterpNone },
    { PEXETSurfaceInterpMethod, PEXETMSurfaceInterpColor },
    { PEXETSurfaceInterpMethod, PEXETMSurfaceInterpDotProduct },
    { PEXETSurfaceInterpMethod, PEXETMSurfaceInterpNormal },
    { PEXETTrimCurveApproxMethod, PEXETMApproxConstantBetweenKnots }
};

static void enum_cb (Widget list, Widget *lists, XmListCallbackStruct *cbs)
{
    XmListDeleteAllItems (lists[1]);
    XmListDeleteAllItems (lists[2]);
    XmListDeleteAllItems (lists[3]);

    PEXEnumTypeDesc *info;
    unsigned long *count;

    int type = standards[cbs->item_position - 1].index;

    Status status = PEXGetEnumTypeInfo (XtDisplay (list), XtWindow (list),
	1, &type, PEXETAll,
	&count, &info);
    
    if (status) {
	for (int i = 0; i < *count; i++) {
	    if (find_option (options, XtNumber (options), type, info[i].descriptor))
		XnWidgetPutStr (lists[1], info[i].descriptor);
	    else
		XnWidgetPutStr (lists[3], info[i].descriptor);
	    info [i].index = type;
	}

	for (i = 0; i < XtNumber (options); i++) {
	    if (type == options[i].index) {
		if (!find_option (info, *count, type, options[i].descriptor))
		    XnWidgetPutStr (lists[2], options[i].descriptor);
	    }
	}

	XFree (info);
	XFree (count);
    }
}

static void close_cb (Widget, XtPointer, XtPointer)
{
    exit (0);
}

static void EnumWindow (Widget parent)
{
    static Widget lists[4];

    Widget dialog = XmCreateFormDialog (parent, "dialog", NULL, 0);
    XnWidgetPutStr (XtParent (dialog), "PEX Enumerated Type Information");

    Widget footer = XnCreateFooter (dialog, NULL, close_cb, NULL, NULL);

    Widget form = XtVaCreateWidget ("form",
	xmFormWidgetClass, dialog,
	XmNfractionBase, 6,
	XmNtopAttachment, XmATTACH_FORM,
	XmNleftAttachment, XmATTACH_FORM,
	XmNbottomAttachment, XmATTACH_WIDGET,
	XmNbottomWidget, footer,
	XmNrightAttachment, XmATTACH_FORM,
	NULL);

    Widget frame1 = XnCreateFrame (form, "Enumeration Types");
    lists[0] = XmCreateScrolledList (frame1, "list", NULL, 0);

    Widget frame2 = XnCreateFrame (form, "Capabilities Supported");
    lists[1] = XmCreateScrolledList (frame2, "list", NULL, 0);

    Widget frame3 = XnCreateFrame (form, "Capabilities Unavailable");
    lists[2] = XmCreateScrolledList (frame3, "list", NULL, 0);

    Widget frame4 = XnCreateFrame (form, "Vendor Extensions");
    lists[3] = XmCreateScrolledList (frame4, "list", NULL, 0);

    XtVaSetValues (lists[0],
	XmNvisibleItemCount, 20,
	NULL);

    XtVaSetValues (XtParent (frame1),
	XmNtopAttachment, XmATTACH_FORM,
	XmNleftAttachment, XmATTACH_FORM,
	XmNbottomAttachment, XmATTACH_FORM,
	XmNrightAttachment, XmATTACH_POSITION,
	XmNrightPosition, 3,
	NULL);

    XtVaSetValues (XtParent (frame2),
	XmNtopAttachment, XmATTACH_FORM,
	XmNleftAttachment, XmATTACH_POSITION,
	XmNleftPosition, 3,
	XmNbottomAttachment, XmATTACH_POSITION,
	XmNbottomPosition, 2,
	XmNrightAttachment, XmATTACH_FORM,
	NULL);

    XtVaSetValues (XtParent (frame3),
	XmNtopAttachment, XmATTACH_POSITION,
	XmNtopPosition, 2,
	XmNleftAttachment, XmATTACH_POSITION,
	XmNleftPosition, 3,
	XmNbottomAttachment, XmATTACH_POSITION,
	XmNbottomPosition, 4,
	XmNrightAttachment, XmATTACH_FORM,
	NULL);

    XtVaSetValues (XtParent (frame4),
	XmNtopAttachment, XmATTACH_POSITION,
	XmNtopPosition, 4,
	XmNleftAttachment, XmATTACH_POSITION,
	XmNleftPosition, 3,
	XmNbottomAttachment, XmATTACH_FORM,
	XmNrightAttachment, XmATTACH_FORM,
	NULL);

    XtAddCallback (lists[0], XmNbrowseSelectionCallback,
	     (XtCallbackProc) enum_cb, (XtPointer) lists);

    XtManageChild (lists[0]);
    XtManageChild (lists[1]);
    XtManageChild (lists[2]);
    XtManageChild (lists[3]);
    XtManageChild (form);
    XtManageChild (dialog);

    for (int i = 0; i < XtNumber (standards); i++)
	XnWidgetPutStr (lists[0], standards[i].descriptor);
}

int main (int argc, char **argv)
{
    XtAppContext app;

    Widget toplevel = XnAppInitialize ("Enum", &app, &argc, argv, NULL, NULL);

    PEXExtensionInfo *pexinfo;
    char str[PEXErrorStringLength];

    if (PEXInitialize (XtDisplay (toplevel), &pexinfo, sizeof (str), str) != 0) {
	printf ("No PEX extension %s.\n", str);
	exit (1);
    }

    EnumWindow (toplevel);

    XtAppMainLoop (app);

    return 0;
}
